/* -*- mode: C++ ; c-basic-offset: 2; indent-tabs-mode: nil -*- */
/*
 * This file allows for SWIG specialization for Java
 */
#if defined(SWIGJAVA)

/* Make all functions and non-constant fields camel-case. */
%rename("%(lowercamelcase)s", %$ismember, %$isvariable, %$not %$hasconsttype) "";
%rename("%(lowercamelcase)s", %$isfunction) "";

%typemap(javapackage) nds2;

%javaconst(0);

#------------------------------------------------------------------------

%define %nds_doc_nl()"<br>
"
%enddef /* %nds_doc_nl */

%define %nds_doc_par()"<p>
"
%enddef /* %nds_doc_nl */

%define %nds_doc_brief(TEXT)
%nds_doc_par()TEXT%nds_doc_nl
%enddef

%define %nds_doc_details(TEXT)
%nds_doc_par()TEXT %nds_doc_nl
%enddef

%define %nds_doc_remark(TEXT)
"REMARK: " TEXT%nds_doc_nl
%enddef
%define %nds_doc_returns(TEXT)
"Returns " TEXT%nds_doc_nl%nds_doc_nl
%enddef

%define %nds_doc_param(CALL,TYPE,DESC)
%enddef

#------------------------------------------------------------------------

%define %nds_doc_class_begin(__CLASS__)
%typemap(javaimports) __CLASS__ "
/** "
%enddef

%define %nds_doc_class_end()
" */"
%enddef

%define %nds_doc_method_begin(__CLASS__,__METHOD__,__CALL__)
%javamethodmodifiers __CLASS__::__METHOD__(__CALL__) "
/** "
%enddef

%define %nds_doc_method_end()
" */
public";
%enddef

%define %nds_doc_body_begin()
""
%enddef

%define %nds_doc_body_end()
""
%enddef

%define %nds_doc_body_none()
""
%enddef

#------------------------------------------------------------------------

%define %nds_namespace() "nds2"
%enddef

#------------------------------------------------------------------------

%include "nds_java_buffer.i"
%include "nds_java_buffers_type.i"
%include "nds_java_channel.i"
%include "nds_java_channel_names_type.i"
%include "nds_java_channels_type.i"

%include "enumsimple.swg"
%include "std_string.i"

%include "nds.i"
%include "jniloader.i"

#endif /* defined(SWIGJAVA) */
