#ifndef NDS_JAVA_CHANNELS_TYPE_I
#define NDS_JAVA_CHANNELS_TYPE_I

%typemap(jni) channels_type "jobjectArray";
%typemap(jtype) channels_type "channel[]";
%typemap(jstype) channels_type "channel[]";
%typemap(javaout) channels_type {
  return $jnicall;
}

%typemap(out) channels_type {
  //---------------------------------------------------------------------
  // find out about the object to convert
  //---------------------------------------------------------------------
  jclass clazz = jenv->FindClass( %nds_namespace"/channel" );
  if ( ! clazz )
  {
    $cleanup;
    return $null;
  }
  jmethodID ctor = jenv->GetMethodID( clazz, "<init>", "(JZ)V" );
  if ( ! ctor )
  {
    $cleanup;
    return $null;
  }
  //---------------------------------------------------------------------
  // Allocate the space
  //---------------------------------------------------------------------
  $result = jenv->NewObjectArray( $1.size( ), clazz, NULL);
  if ( ! $result )
  {
    $cleanup;
    return $null;
  }
  //---------------------------------------------------------------------
  // Translate vector into array
  //---------------------------------------------------------------------
  jsize         i = 0;
  jlong         cptr;
  jobject       obj;
  for ( channels_type::iterator
          cur = $1.begin( ),
          last = $1.end( );
        cur != last;
        ++cur,
        ++i )
  {
    *(channel**)(&cptr) = new channel(*cur);
    obj = jenv->NewObject( clazz, ctor, cptr, JNI_TRUE );
    if ( ! obj )
    {
      $cleanup;
      return $null;
    }
    jenv->SetObjectArrayElement( $result, i, obj );
  }
}

#endif /* NDS_JAVA_CHANNELS_TYPE_I */
